<?php
/**
 * FAL Support
 *
 * @param	array		$paramArray: $markerArray and $config of the current news item in an array
 * @param	[type]		$conf: ...
 * @return	array		the processed markerArray
 */
function user_imageMarkerFunc($paramArray, $conf){
	$markerArray = $paramArray[0];
	$lConf = $paramArray[1];
	$pObj = &$conf['parentObj']; // make a reference to the parent-object
	$row = $pObj->local_cObj->data;

	$imageNum = isset($lConf['imageCount']) ? $lConf['imageCount'] : 1;
	$imageNum = t3lib_utility_Math::forceIntegerInRange($imageNum, 0, 100);
	$theImgCode = '';

	// to get correct files, set uid
	// workspaces
	if (isset($row['_ORIG_uid']) && ($row['_ORIG_uid'] > 0)) {
		// draft workspace
		$uid = $row['_ORIG_uid'];
	} else {
		// live workspace
		$uid = $row['uid'];
	}
	// translations - i10n mode
	if ($row['_LOCALIZED_UID']) {
		//i10n mode = exclude   -> do nothing
		//i10n mode = mergeIfNotBlank
		$confArr_ttnews = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['tt_news']);
		if (!$confArr_ttnews['l10n_mode_imageExclude']) {
			if ($row['image']) $uid = $row['_LOCALIZED_UID'];
		}
	}

	$cc = 0;
	$shift=false;

	/* Images from FileReferences */
	$fileRepository = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Resource\\FileRepository');
	$fileObjects = $fileRepository->findByRelation('tt_news', 'image', $uid);

	// localisation of FAL data
	/*TODO
	while (list($key,$val) = each($damRows)) {
		$damRows[$key] =  $GLOBALS['TSFE']->sys_page->getRecordOverlay('tx_dam', $val, $GLOBALS['TSFE']->sys_language_uid, '');
	}
	*/

	// remove first img from the image array in single view if the TSvar firstImageIsPreview is set
	if (((count($fileObjects) > 1 && $pObj->config['firstImageIsPreview']) || (count($fileObjects) >= 1 && $pObj->config['forceFirstImageIsPreview'])) && $pObj->theCode == 'SINGLE') {
		array_shift($fileObjects);
		$shift = true;
	}
	// get img array parts for single view pages
	if ($pObj->piVars[$pObj->pObj['singleViewPointerName']]) {
		$spage = $pObj->piVars[$pObj->config['singleViewPointerName']];
		$astart = $imageNum * $spage;
		$fileObjects = array_slice($fileObjects, $astart, $imageNum);
	}

	$iConf = $lConf['image.'];
	while (list($key, $val) = each($fileObjects)) {
		if ($cc == $imageNum) break;
		if ($val) {
			// get and set properties of File / FileReference
			$title = $val->getTitle();
			$alt = $val->getAlternative();
			$name = $val->getName();
			$description = $val->getDescription();
			$iConf['file'] = $val->getPublicUrl();
			$iConf['altText'] = !empty($alt) ? $alt : $name;
			$iConf['titleText'] = !empty($title) ? $title : $name;
			$caption = !empty($description) ? $description : '';
		}
		$pObj->local_cObj->setCurrentVal($val);

		// enables correct use of extension perfectlightbox
		if ($shift) $GLOBALS['TSFE']->register['IMAGE_NUM_CURRENT'] = $cc + 1;
		else $GLOBALS['TSFE']->register['IMAGE_NUM_CURRENT'] = $cc;

		$theImgCode .= $pObj->local_cObj->wrap($pObj->local_cObj->IMAGE($iConf).$pObj->local_cObj->stdWrap($caption, $lConf['caption_stdWrap.']), $lConf['imageWrapIfAny_'.$cc]); //$pObj->local_cObj->IMAGE($iConf);
		$cc++;
	}

	// fill marker
	$markerArray['###NEWS_IMAGE###'] = '';
	if ($cc) {
		$markerArray['###NEWS_IMAGE###'] = $pObj->local_cObj->wrap(trim($theImgCode), $lConf['imageWrapIfAny']);
	}
	// noImage_stdWrap
	else {
		$markerArray['###NEWS_IMAGE###'] = $pObj->local_cObj->stdWrap($markerArray['###NEWS_IMAGE###'],$lConf['image.']['noImage_stdWrap.']);
	}

	return $markerArray;
}
