<?php
/**
 * FAL Support
 *
 * @param	array		$markerArray: array filled with markers from the getItemMarkerArray function in tt_news class. see: EXT:tt_news/pi/class.tx_ttnews.php
 * @param	[type]		$conf: ...
 * @return	array		the changed markerArray
 */
function user_itemMarkerArrayFunc($markerArray, $conf) {
	$pObj = &$conf['parentObj']; // make a reference to the parent-object
	$row = $pObj->local_cObj->data;
	$markerArray['###FILE_LINK###'] = '';
	$markerArray['###TEXT_FILES###'] = '';

	//load TS config for newsFiles from tt_news
	$conf_newsFiles = $pObj->conf['newsFiles.'];
	//Important: unset path
	$conf_newsFiles['path'] = '';

	$local_cObj = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('tslib_cObj');

	//workspaces
	if (isset($row['_ORIG_uid']) && ($row['_ORIG_uid'] > 0)) {
		// draft workspace
		$uid = $row['_ORIG_uid'];
	} else {
		// live workspace
		$uid = $row['uid'];
	}
	// Check for translation
	if ($row['_LOCALIZED_UID']) {
		//i10n mode = mergeIfNotBlank
		if ($row['news_files']) $uid = $row['_LOCALIZED_UID'];
	}

	/* Files from FileReferences */
	$fileRepository = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Core\\Resource\\FileRepository');
	$fileObjects = $fileRepository->findByRelation('tt_news', 'news_files', $uid);

	// localisation of FAL data
	/* TODO
	while (list($key,$val) = each($damFiles['rows'])) {
		$damFiles['rows'][$key] =  $GLOBALS['TSFE']->sys_page->getRecordOverlay('tx_dam', $val, $GLOBALS['TSFE']->sys_language_uid, '');
	}
	*/

	if (is_array($fileObjects)) {
		$files_stdWrap = \TYPO3\CMS\Core\Utility\GeneralUtility::trimExplode('|', $pObj->conf['newsFiles_stdWrap.']['wrap']);

		$filelinks = '';
		while (list($key, $val) = each($fileObjects)) {
			if ($val) {
				$local_cObj->start($fileObjects[$key]);
				// get title and name of File / FileReference and set title-tag
				$title = $val->getTitle();
				$name = $val->getName();
				$conf_newsFiles['title'] = !empty($title) ? $title : $name;
				// get and set path of File
				$path = str_replace($name, '', $val->getPublicUrl());
				$conf_newsFiles['path'] = $path;
				// set label
				$conf_newsFiles['labelStdWrap.']['cObject'] = 'TEXT';
				$conf_newsFiles['labelStdWrap.']['cObject.']['value'] = !empty($title) ? $title : $name;
				// create file link
				$filelinks .= $local_cObj->filelink($name, $conf_newsFiles);
			}
		}
		if ($filelinks) {
			$markerArray['###FILE_LINK###'] = $filelinks.$files_stdWrap[1];
			$markerArray['###TEXT_FILES###'] = $files_stdWrap[0].$pObj->local_cObj->stdWrap($pObj->pi_getLL('textFiles'), $pObj->conf['newsFilesHeader_stdWrap.']);
		}
	}

	return $markerArray;
}
